module bulletmover (clk, reset, addBullet, updateBullets, valid, processing, shift, load, update);

input clk ;
input reset ;
input addBullet ;
input updateBullets ;
input valid ;
output shift ;
output processing ;
output load;
output update;

reg _load;
assign load = _load;
reg _shift;
assign shift = _shift;
reg _updateBullets;
assign updateBullets = _updateBullets;
reg _update;
assign update = _update;

reg [3:0] nr_processed;

//variables for addBullet
reg addingBullet;
reg foundSlot;
reg lastState; //cleanup state for addBullet loop

//variables for updateBullets
reg updatingBullets;
reg movePhase;


assign processing = addingBullet | updatingBullets;


always@(posedge clk) begin
	if(reset) begin
		_load <= 0;
	end
	else begin
		_load <= 0;
		if(addBullet) begin
			nr_processed <= 0;
			addingBullet <= 1;
			foundSlot <= 0;
			lastState <= 0;
		end
		else if (updateBullets) begin
			nr_processed <= 0;
			updatingBullets <= 1;
			movePhase <= 1;
		end
		
		if(addingBullet) begin
			_update <= 0;
			if(foundSlot) begin
				nr_processed <= nr_processed +1;
				if(nr_processed ==0) begin
					addingBullet <= 1;
				end 
				else if(nr_processed == 1) begin
					addingBullet <= 1;
					_load <= 1;
				end
				else begin
					addingBullet <= 0;
					_load <= 0;
					foundSlot <= 0;
					_shift <= 0;
				end
			end
			else begin
				_shift <= 1;
				nr_processed <= nr_processed + 1;
				if(nr_processed < 7 & !foundSlot) begin
					if(!valid) begin
					 	foundSlot <= 1;
					 	nr_processed <= 0;
					end
				end 
				else if(nr_processed >=4) begin
					addingBullet <= 0;
				end
			end
		end
		else if(updatingBullets) begin
			//update bullet positions
			if(movePhase) begin
				_shift <= 1;
				if(nr_processed <=1) begin
					nr_processed <= nr_processed +1;
				end
				else if(nr_processed <=5) begin
					nr_processed <= nr_processed +1;
					_update <= 1;
					_load <= 1;
				end
				else if(nr_processed >=6) begin
					updatingBullets <= 0;
					_update <= 0;
					_load <= 0;
					_shift <= 0;
				end
			end
		end
	end
end
endmodule 
