------------------------------------------------------
-- LogiBLOX MUX Module "ColChooser"
-- Created by LogiBLOX version D.24
--    on Thu Feb 22 16:36:32 2001
-- Attributes 
--    MODTYPE = MUX
--    BUS_WIDTH = 8
--    OPTYPE = TYPE_1
--    ENCODING = BINARY
--    STYLE = MAX_SPEED
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY ColChooser IS
  PORT(
    S: IN std_logic_vector(2 DOWNTO 0);
    O: OUT std_logic;
    M: IN std_logic_vector(7 DOWNTO 0));
END ColChooser;

-- synopsys translate_off
ARCHITECTURE sim OF ColChooser IS
    SIGNAL START_PULSE: std_logic := '1';
BEGIN
  PROCESS
    VARIABLE VS: std_logic_vector(2 DOWNTO 0);
    VARIABLE VO: std_logic;
    VARIABLE VM: std_logic_vector(7 DOWNTO 0);
    BEGIN
      VS := stdvec2mvl(S);
      VM := stdvec2mvl(M);
      xb_mux_type_1(
             VM,
             VS,
             BINARY,
             VO);
      O <= VO;
      IF (START_PULSE='1') THEN
        START_PULSE <= '0' AFTER 1 ns;
      END IF;
      WAIT ON S, M, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
