------------------------------------------------------
-- LogiBLOX DATA_REG Module "DREG10"
-- Created by LogiBLOX version D.24
--    on Thu Mar 01 13:29:34 2001
-- Attributes 
--    MODTYPE = DATA_REG
--    BUS_WIDTH = 10
--    STYLE = CLB_FD
--    SYNC_VAL = 0
--    USE_RPM = FALSE
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY DREG10 IS
  PORT(
    D_IN: IN std_logic_vector(9 DOWNTO 0);
    SYNC_CTRL: IN std_logic;
    CLK_EN: IN std_logic;
    CLOCK: IN std_logic;
    Q_OUT: OUT std_logic_vector(9 DOWNTO 0));
END DREG10;

-- synopsys translate_off
ARCHITECTURE sim OF DREG10 IS
    SIGNAL START_PULSE: std_logic := '1';
BEGIN
  PROCESS
    VARIABLE VD_IN: std_logic_vector(9 DOWNTO 0);
    VARIABLE VASYNC_CTRL: std_logic;
    VARIABLE VSYNC_CTRL: std_logic;
    VARIABLE VCLK_EN: std_logic;
    VARIABLE VCLOCK: std_logic;
    VARIABLE VQ_OUT: std_logic_vector(9 DOWNTO 0);
    BEGIN
      VD_IN := stdvec2mvl(D_IN);
      VASYNC_CTRL := '0';
      VSYNC_CTRL := stdbit2mvl(SYNC_CTRL);
      xb_data_reg(
             START_PULSE,
             VD_IN,
             VASYNC_CTRL,
             ('0','0','0','0','0','0','0','0','0','0'),
             VSYNC_CTRL,
             ('0','0','0','0','0','0','0','0','0','0'),
             VQ_OUT);
      IF(
       (CLOCK'EVENT AND stdbit2mvl(CLOCK)='1' AND stdbit2mvl(CLOCK'LAST_VALUE)='0' AND stdbit2mvl(CLK_EN)='1')
       OR ( stdbit2mvl(START_PULSE)='1')
      ) THEN
      Q_OUT <= VQ_OUT;
      ELSIF(
       (stdbit2mvl(CLOCK) = 'X')
       OR (CLOCK'EVENT AND stdbit2mvl(CLOCK)='1' AND stdbit2mvl(CLOCK'LAST_VALUE)='0'
           AND stdbit2mvl(CLK_EN) = 'X' )
      ) THEN
      VQ_OUT := ('X','X','X','X','X','X','X','X','X','X');
      Q_OUT <= VQ_OUT;
      END IF;
      IF (START_PULSE='1') THEN
        START_PULSE <= '0' AFTER 1 ns;
      END IF;
      WAIT ON D_IN, SYNC_CTRL, CLK_EN, CLOCK, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
