module GameState (up, down, left, right, reset, clk, HeadX, HeadY, Seg1, Seg2, Seg3, Seg4, GameOver) ;

input up ;
input down ;
input left ;
input right ;
input reset ;
input clk ;
output [9:0] HeadX ;
output [9:0] HeadY ;
output [11:0] Seg1 ;
output [11:0] Seg2 ;
output [11:0] Seg3 ;
output [11:0] Seg4 ;
output GameOver;

// add your declarations here
// X and Y of the head of the snake
reg [9:0] X;
reg [9:0] Y;

// Direction and length of first segment
reg [1:0] Seg1Dir;
reg [9:0] Seg1Len;

// Direction and length of second segment
reg [1:0] Seg2Dir;
reg [9:0] Seg2Len;

//Direction and length of third segment
reg [1:0] Seg3Dir;
reg [9:0] Seg3Len;

//Direction and length of fourth segment
reg [1:0] Seg4Dir;
reg [9:0] Seg4Len;

reg gameover;
reg L;
reg R;
reg U;
reg D;

//assign outputs
assign HeadX = X;
assign HeadY = Y;
assign Seg1 = {Seg1Dir,Seg1Len};
assign Seg2 = {Seg2Dir,Seg2Len};
assign Seg3 = {Seg3Dir,Seg3Len};
assign Seg4 = {Seg4Dir,Seg4Len};
assign GameOver = gameover;
// add your code here
always @(posedge clk) begin

	if (reset) begin
		X <= 300;
		Y <= 300;
		Seg1Dir <= 3;
		Seg1Len <= 100;
		Seg2Dir <= 0;
		Seg2Len <= 0;
		Seg3Dir <= 3;
		Seg3Len <= 0;
		Seg4Dir <= 0;
		Seg4Len <= 0;
		gameover <= 0;
		L <= 1;
		R <= 0;
		U <= 1;
		D <= 1;
	end
	else if (gameover != 1) begin 
	
	    if (up && U && (D != 0)) begin   //pressed up
		Y <= Y - 30;
		if(Seg1Dir == 2)
		    X <= X + 10;
		else
		    X <= X - 10;
		if(Seg3Len >= 10) begin
		    Seg4Len <= Seg3Len - 10;
		    Seg3Len <= Seg2Len;
		    Seg2Len <= Seg1Len - 10;
		end
		else if(Seg2Len >= 10) begin
		    Seg4Len <= 0;
		    Seg3Len <= Seg2Len - 10;
		    Seg2Len <= Seg1Len - 10;
		end
		else begin
		    Seg4Len <= 0;
		    Seg3Len <= 0;
		    Seg2Len <= Seg1Len - 20;
		end
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 0;
		Seg1Len <= 20;
		U <= 0;
		L <= 1;
		R <= 1;
		D <= 1;
	end
	else if (down && D && (U != 0)) begin
		Y <= Y + 30;
		if(Seg1Dir == 2)
		   X <= X + 10;
		else
		   X <= X - 10;
		if(Seg3Len >= 10) begin
		   Seg4Len <= Seg3Len - 10;
		   Seg3Len <= Seg2Len;
		   Seg2Len <= Seg1Len - 10;
		end
		else if(Seg2Len >= 10) begin
		   Seg4Len <= 0;
		   Seg3Len <= Seg2Len - 10;
		   Seg2Len <= Seg1Len - 10;
		end   
		else begin
		   Seg4Len <= 0;
		   Seg3Len <= 0;
		   Seg2Len <= Seg1Len - 20;
		end
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 1;
		Seg1Len <= 20;
		D <= 0;
		L <= 1;
		R <= 1;
		U <= 1;
	end
	else if (right && R && (L != 0)) begin
		X <= X + 30;
		if(Seg1Dir == 0)
		   Y <= Y + 10;
		else
		   Y <= Y - 10;
		if(Seg3Len >= 10) begin
		   Seg4Len <= Seg3Len - 10;
		   Seg3Len <= Seg2Len;
		   Seg2Len <= Seg1Len - 10;
		end
		else if(Seg2Len >= 10) begin
		   Seg4Len <= 0;
		   Seg3Len <= Seg2Len - 10;
		   Seg2Len <= Seg1Len - 10;
		end   
		else begin
		   Seg4Len <= 0;
		   Seg3Len <= 0;
		   Seg2Len <= Seg1Len - 20;
		end
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 3;
		Seg1Len <= 20;
		R <= 0;
		L <= 1;
		D <= 1;
		U <= 1;
	end
	else if (left && L && (R != 0)) begin
		X <= X - 30;
		if(Seg1Dir == 0)
		     Y <= Y + 10;
		else
		     Y <= Y - 10;
		if(Seg3Len >= 10) begin
		   Seg4Len <= Seg3Len - 10;
		   Seg3Len <= Seg2Len;
		   Seg2Len <= Seg1Len - 10;
		end
		else if(Seg2Len >= 10) begin
		   Seg4Len <= 0;
		   Seg3Len <= Seg2Len - 10;
		   Seg2Len <= Seg1Len - 10;
		end   
		else begin
		   Seg4Len <= 0;
		   Seg3Len <= 0;
		   Seg2Len <= Seg1Len - 20;
		end
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 2;
		Seg1Len <= 20;
		L <= 0;
		R <= 1;
		D <= 1;
		U <= 1;
	end
	else begin
		if(Seg1Dir == 0) begin
		   Y <= Y - 2;
		   if( Y  <= 10)  //checking top boundary
		   	gameover <= 1;
		end
		if(Seg1Dir == 1) begin             
		   Y <= Y + 2;
		   if( Y  >= 470)   //checking bottom boundary
		   	gameover <= 1;
		end
		if(Seg1Dir == 2) begin
		   X <= X - 2;
		   if ( X  <= 10)  //checking left boundary
		   	gameover <= 1;
		end
		if(Seg1Dir == 3) begin
		   X <= X + 2;
		   if( X  >= 630)    //checking right boundary
		   	gameover <= 1;
		end
		if (Seg4Len != 0 ) begin
			 Seg1Len <= Seg1Len + 1;
			 Seg4Len <= Seg4Len - 1;
	  	end
		else if (Seg3Len != 0 ) begin
			 Seg1Len <= Seg1Len + 1;
			 Seg3Len <= Seg3Len - 1;
	        end
		else if (Seg2Len != 0 ) begin
			 Seg1Len <= Seg1Len + 1;
			 Seg2Len <= Seg2Len - 1;	
		end	
	end
   end
end

endmodule 

