module RANDOM (CLK, NEW_KEY, SCAN_CODE, X_COORD, RAND_NUM);
input CLK, NEW_KEY;
input [7:0] SCAN_CODE, X_COORD;
output [7:0] RAND_NUM;
reg [7:0] RAND_NUM;
reg [7:0] RAND_SEED;
reg [8:0] TEMP;
reg [23:0] COUNTER;
reg FIRST_TIME;

always @(posedge CLK) begin
	if(SCAN_CODE == 'h76) begin	// esc - initial state
		COUNTER <= 0;
		RAND_SEED <= 0;
		FIRST_TIME <= 1;
	end
	else begin // 1
	if(FIRST_TIME == 1 && NEW_KEY == 1) begin
		FIRST_TIME <= 0;
		RAND_SEED <= X_COORD;
	end
	end // 1
	COUNTER <= COUNTER + 1;
	if(COUNTER == 16777213 && FIRST_TIME == 0) begin // largest 32 bit prime number - used to make sure repetition does not occur very often
		TEMP = RAND_SEED + X_COORD;
		RAND_NUM <= TEMP[7:0];
	end
end

endmodule 
