------------------------------------------------------
-- LogiBLOX MUX Module "uppermux"
-- Created by LogiBLOX version D.24
--    on Wed Mar 07 16:59:43 2001
-- Attributes 
--    MODTYPE = MUX
--    BUS_WIDTH = 4
--    OPTYPE = TYPE_2
--    INPUT_BUSSES = 6
--    ENCODING = BINARY
--    STYLE = MAX_SPEED
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY uppermux IS
  PORT(
    S: IN std_logic_vector(2 DOWNTO 0);
    O: OUT std_logic_vector(3 DOWNTO 0);
    MA: IN std_logic_vector(3 DOWNTO 0);
    MB: IN std_logic_vector(3 DOWNTO 0);
    MC: IN std_logic_vector(3 DOWNTO 0);
    MD: IN std_logic_vector(3 DOWNTO 0);
    ME: IN std_logic_vector(3 DOWNTO 0);
    MF: IN std_logic_vector(3 DOWNTO 0));
END uppermux;

-- synopsys translate_off
ARCHITECTURE sim OF uppermux IS
    SIGNAL START_PULSE: std_logic := '1';
BEGIN
  PROCESS
    VARIABLE VS: std_logic_vector(2 DOWNTO 0);
    VARIABLE VO: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMA: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMB: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMC: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMD: std_logic_vector(3 DOWNTO 0);
    VARIABLE VME: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMF: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMG: std_logic_vector(3 DOWNTO 0);
    VARIABLE VMH: std_logic_vector(3 DOWNTO 0);
    BEGIN
      VS := stdvec2mvl(S);
      VMA := stdvec2mvl(MA);
      VMB := stdvec2mvl(MB);
      VMC := stdvec2mvl(MC);
      VMD := stdvec2mvl(MD);
      VME := stdvec2mvl(ME);
      VMF := stdvec2mvl(MF);
      xb_mux_type_2(
             VMA,
             VMB,
             VMC,
             VMD,
             VME,
             VMF,
             VMG,
             VMH,
             VS,
             BINARY,
             VO);
      O <= VO;
      IF (START_PULSE='1') THEN
        START_PULSE <= '0' AFTER 1 ns;
      END IF;
      WAIT ON S, MA, MB, MC, MD, ME, MF, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
